#ifndef FIBO_H
#define FIBO_H

#include <stdio.h>
#include <stdlib.h>
#include <gmp.h>

#define FIBO_EXTERN extern
typedef unsigned int FIBO_TYPE;
typedef mpz_t FIBO_TYPE_BIG;

FIBO_EXTERN
FIBO_TYPE fibonacci_iter(FIBO_TYPE n);

FIBO_EXTERN
FIBO_TYPE fibonacci_log(FIBO_TYPE n);

FIBO_EXTERN
FIBO_TYPE_BIG *fibonacci_log2(FIBO_TYPE_BIG n);

#endif /* FIBO_H */
